/*
  "Ritual to the goddess of Teraflops"

  ideen:

   -vuur erboven
   -HF in achtergrond

  started: end 1992
  finished: Never..


  by HWN
 */

#include "standard.inc"
#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

#define zoom =
camera {
    location <1.5, 1.6, -1.8>
    sky y
    aspect 4/3
    fov 90
    look_at <0, 1.35, 0.5>
    translate <1.5, 0, 0.5>
}

object {
    light_source {
        <10, 20, -10> color Grey90
        spotlight
        point_at 2 * y
// radius 90        
// falloff 70        
        tightness 0.05
    }
}

#define Horizon = color DarkPurple
#define Darknight = color red 0.074 green 0.0 blue 0.143	// even darker


options {
    background -y color Darknight
}

#define Sky_Globe = object {
    sphere { <0>, 100 }
    texture {
        color Horizon
        /*    gradient y
    color_map  {
      [0.00 0.5 color Horizon color Black]
      [0.50 1.0 color Black color Black]
    }*/
        scale <50, 80, 50>
        ambient 0.3 diffuse 0.0 // no shadows
    }
}

/*
 * Desert, with sand
 */
#define Floor_Plane = object {
    plane { y, 0 }
    texture {
// waves 0.3 frequency 0.3 phase 0.0        
        color red 0.506 green 0.375 blue 0.102
        ambient 0.3
        diffuse 0.4	// donker
    }
}

/*
 * start of altar part
 */
#define Grnt19 = texture {
    color Grey40
}
/*
  granite
  turbulence 0.0
  color_map {
    [0.0 0.3 color White   color DimGray]
    [0.2 0.4 color DimGray color DimGray]
    [0.4 0.6 color DimGray color DimGray]
    [0.6 1.0 color DimGray color DimGray]
  }
  0.02
}

*/

#define gleuf = object { Cylinder_Y scale <0.1, 1, 0.1> inverse }
#define bovenrichel = intersection {
    plane { x, 0 rotate <0, -45, 0> }
    plane { -x, 0 rotate <0, 45, 0> }
    cylinder { <(-1.2-.55), 1, -0.5>, <1.2 -.55, 1, -0.5>, .05 }
}

#define onderrichel = object {
    Cylinder_X scale <1, 0.05, 0.05>
    translate <0, 0.25, -0.6> inverse
}

#define altar = object {
    composite {
        intersection {
            box { <-0.5, 0, -0.5>, <0.5, 1.05, 0.5> }
            object { gleuf translate <0.5, 0, 0.5> }
            object { gleuf translate <0.5, 0, -0.5> }
            object { gleuf translate <-0.5, 0, -0.5> }
            object { gleuf translate <-0.5, 0, 0.5> }
        }
        box { <-0.5, 1, -0.5>, <0.5, 1.05, 0.5> }
        object { bovenrichel }
        object { bovenrichel rotate <0, 90, 0> }
        object { bovenrichel rotate <0, 180, 0> }
        object { bovenrichel rotate <0, 270, 0> }
        intersection {
            box { <-0.6, 0, -0.6>, <0.6, 0.25, 0.6> }
            object { onderrichel }
            object { onderrichel rotate <0, 90, 0> }
            object { onderrichel rotate <0, 180, 0> }
            object { onderrichel rotate <0, 270, 0> }
        }
        
    }
    texture {
        Grnt19
        specular 0.1
        roughness 0.5
    }
}

#define SandColor = color red 0.84 green 0.79 blue 0.53

#define beige_plastic = texture {
    color SandColor
    roughness 0.2
    specular 0.2
    ambient 0.2
    diffuse 0.5
}

#define traprot = 25
#define buisbox = box { <-0.16, -0.015, -0.2>, <0.16, 0.225, 0.1> }

#define monitor_voet = composite {	// voetje
    object {
        cylinder { -.0075*y, .0075*y, .15 }
        translate <0, -0.1, 0>
    }
    object {
        cylinder { -.05*y, .05*y, .05 }
        translate <0, -0.05, 0>
    }
    translate <0, 0, 0.1>
}

#define monitor_body = composite {
    intersection { // trapeziumvormige buishouder
        box { <-.2, .25, 0>,< .2, 0, .3> }
        plane { -x, 0 rotate 15*y  translate -0.16*x }
        plane { x, 0 rotate -15*y translate 0.16*x }
        plane { y, 0 rotate <20, 0, 0>  translate <0, 0.23, 0> }
    }
    intersection { //voorkant
        box { <-0.2, -0.045, -0.1>, <0.2, 0.255, 0.0> }
        object {
            buisbox
            inverse
        }
    }
}

#define beeld = texture {
    image_map { gif "povscreen.gif" once interpolate 2 }
    specular 0.3
    roughness 0.1
    ambient 0.8
    diffuse 0.1
    scale <0.32, 0.24, 1>
    translate <-0.16, -0.015, 0>
}

#define buis = object {
    sphere { <0, 0.1, 1.92>, 2 }
    clipped_by { object { buisbox } }
    texture { beeld }
}

#define monitor = composite {
    object { buis }
    object { monitor_body }
    rotate <10, 0, 0>
    object { monitor_voet }
    texture { beige_plastic }
    translate 0.1*y
}

/*
 * boek in XZ vlak
 */

#define closed_book = composite {
    object { //cover
        intersection {
            union { //outside
                box { <0, -0.025, 0>, <0.2, 0.025, 0.3> }
                intersection {
                    object { Cylinder_Z scale <0.025, 0.025, 1> }
                    box { <-1, -0.03, 0>, <0.1, 0.03, 0.3> }
                }
            }
            union {
                box { <0, -0.02, -0.1>, <0.3, 0.02, 0.4> }
                object { Cylinder_Z scale <0.02, 0.02, 1> }
                inverse
            }
        }
        texture {
            color Red
        }
    }
    object {
        composite {
            box { <0.0, -0.02, 0.01>, <0.19, 0.02, 0.29> }
            cylinder {
                <0, 0, -.14>,< 0, 0, .14>, .02
                translate <0, 0, 0.15>
            }
        }
        texture { color White }
    }
    translate 0.025*y
}


#include "keyboard.inc"

composite {
    object { altar }
    object { monitor rotate <0, -30, 0> translate <-0.3, 1.05, 0.3> }
    object { closed_book rotate <0, 45, 0> translate <0.2, 1.05, 0.3> }
    object { keyboard translate <-0.1, 1.07, -0.35> }
}

#define hill = object {
    sphere { <0>, 1 translate <0, -0.2, 0> }
    texture {
// waves 0.3 frequency 0.3 phase 0.0        
        color red 0.506 green 0.375 blue 0.102
        ambient 0.3
        diffuse 0.4	// donker
    }
}

/*  END ALTAR */

camera { zoom }

composite { //hills
    object {
        hill
        scale <20, 5, 10>
        translate <-30, 0, 50>
    }
    object {
        hill
        scale <11, 6.5, 12>
        translate <-33, 0, 44>
    }
    object {
        hill
        scale <15, 4, 10>
        rotate <10>
        translate <-20, 0, 50>
    }
    object {
        hill
        scale <5, 3, 16>
        rotate <0, 0, 10>
        translate <-50, 0, 40>
    }
    object {
        hill
        scale <15, 4, 10>
        rotate <10>
        translate <-60, 0, 50>
    }
    translate <-20, 0, -15>
}

object {
    Floor_Plane
}

//object {  Sky_Globe}


/*********************CRAY****************/

/*
 * TEXTURES
 */

#define brownplastic = texture {
    roughness 0.2
    specular 0.2
    ambient 0.2
    diffuse 0.5
    color VeryDarkBrown
}

/***************************************************************************
 * OBJECTS								   *
 ***************************************************************************/

/*
 * CRAY-TOWER
 */

/*
 * intersect shape, projected on XY plane
 */

#define intersectshape = intersection {
    plane {  x, 0 rotate <0, 0, 15> translate 2 * x }
    intersection {
        plane { -x, 0 rotate <0, 0, 10> }
        plane { -y, 0 }
        inverse
        translate <1.1, 1.2, 0>
    }
    intersection {
        plane { -x, 0 }
        plane { -x, 0 rotate <0, 0, 60> }
        translate <1.3, 1.0, 0>
        inverse
    }
}

#define crayquart = object {
    intersection {
        plane { y, 3.7 }
        plane { -y, 0 }
        object { intersectshape }
        object { intersectshape rotate <0, 45, 0> scale <1.3, 1, 1.3> } // 1.3 = sqrt(2) - epsilon
        object { intersectshape rotate <0, 90, 0> }
        plane { -x, 0 }
        plane { z, 0 }
    }
    bounded_by {
        box { <0, 0, -2>, <2, 3.7, 0> }
    }
    translate <0.2, 0, -0.2>
}

#define computrons = composite {
    object { 		// The teraflops are pouring out! :)
        light_source {
            <0, 0.01, 0> color green 5.0
            attenuation 2
            spotlight
            point_at y
// radius 82            
// falloff 89.5            
            tightness 0.3
        }
    }
// object { box { <-0.1, 0, -0.1>, <0.1, 0.1, -0.5> } } //small reflector to keep altar in normal color    
}

#define cray = composite {
    object { crayquart rotate <0> }
    object { crayquart rotate <0, 90, 0> }
    object { crayquart rotate <0, 180, 0> }
    object { crayquart rotate <0, 270, 0> }
    
    object { computrons }
    
    texture {
        brownplastic
    }
}

/*
 * PEDESTAL
 */
#define Pedestal_Texture = texture {
// PinkAlabaster		// Very nice texture    
// scale <0.15, 0.15, 0.15>    
    color Pink
    roughness 0.2
    specular 0.2
    reflection 0.1
    ambient 0.7
    diffuse 0.3
}

#define stair_part = box { <-1, 0, -0.5>, <1, 0.125, 0.5> }

#define stair_plane = plane { -z, 0 rotate <55, 0, 0> translate <0, 0, -4> }

#define puddle = object {
    intersection {
        plane { y, 0.1 }
        union {
            sphere { <0>, 3 }
            sphere { 4 * z, 5 }
        }
    }
    texture {
        colour Blue
        ambient 0.1
        diffuse 0.1
        reflection 0.6
// ripples 0.4        
        scale <10>
    }
}

#define stairs = object {
    composite {
        object { stair_part translate <0, 0.000, -3.82148> }
        object { stair_part translate <0, 0.125, -3.642963> }
        object { stair_part translate <0, 0.250, -3.4644445> }
        object { stair_part translate <0, 0.375, -3.285926> }
        object { stair_part translate <0, 0.500, -3.1074075> }
        object { stair_part translate <0, 0.625, -2.928889> }
        object { stair_part translate <0, 0.750, -2.7503705> }
        object { stair_part translate <0, 0.875, -2.571852> }
    }
    translate <0, 0, 0.2>
}

#define railing1 = intersection {
    box { <-1.25, 0, -0.5>, <-1, 0.25, 4> rotate <-35, 0, 0> translate <0, 0, -4> }
    plane { -y, 0 }
    plane { y, 1 }
}
#define railing2 = intersection {
    box { <1, 0, -0.5>, <1.25, 0.25, 4> rotate <-35, 0, 0> translate <0, 0, -4> }
    plane { -y, 0 }
    plane { y, 1 }
}

#define railing = composite {
    object {	railing1 }
    object {	railing2 }
}

// tan(35) == 0.700207
// /
// /35  1
// ?
// 1/tan 35 = ? = 1.428148, ?/8 = 0.1785185

#define pedestal = composite {
    composite {
        object {
            intersection {
                plane { -y, 0 }
                plane { y, 1 }
                object { stair_plane }
                object { stair_plane rotate <0, 90, 0> }
                object { stair_plane rotate <0, 270, 0> }
                object { stair_plane rotate <0, 180, 0> }
            }
            bounded_by {
                box { <-4, 0, -4>, <4, 1, 4> }
            }
        }
        
        object { railing rotate <0, 90, 0> }
        object { railing rotate <0, 180, 0> }
        object { railing rotate <0, 270, 0> }
        object { railing rotate <0> }
        
        
        
    }
    
    object {
        stairs
        rotate <0>
    }
    object {
        stairs
        rotate <0, 90, 0>
    }
    object {
        stairs
        rotate <0, 180, 0>
    }
    object {
        stairs
        rotate <0, 270, 0>
    }
    
    texture {
        Pedestal_Texture
    }
}


object {	// mirage
    puddle
    translate <10, 0, 60>
}


composite {
    object {
        pedestal
    }
    object {
        cray
        translate y
    }
    translate 7 * z
}
