/*
 * GLOBAL VARIABLES. They are declared EXTERN, which means extern. global
 * storage for all variables is done in _one_ source file (initialize.c)
 *
 * Distributed under terms of the GNU General Public License, see "copying"
 *
 * (C) 1993, 1994 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>
 */

/* resolution */
EXTERN unsigned int xres,
                yres;
EXTERN bool     trace_start,
                keyboard_exit,	/* allow early break via keypress? */
                continue_flag,	/* continue picture? */
                silent_mode,
                test_flag;


EXTERN long int test_stat,	/* variable for debugging and testing */
                debug_options;

EXTERN FILE    *error_out;	/* for putting errors in */
EXTERN int      inputlines;
EXTERN char    *this_file;
EXTERN int      noo,		/* number of objects at toplevel */
                max_trace_level,/* maximum trace level */

                tries,		/* number of tries per pixel */
                iter_override;	/* number of tries set from commandline  */

/* time information */
EXTERN Flt      time1,
                time2,		/* time limits */
                Time;		/* current time */



/* statistics */
EXTERN struct global_stat_struc global_stats;
EXTERN struct line_stat_struc line_stats;


EXTERN color    background_color;	/* the background color */
EXTERN vector   bggradient;	/* gradient in which direction? */


EXTERN Flt      tmpFlt;		/* for the vector macros */
EXTERN vector   tmpvector;	/* just something ..  (hhwaah) */

EXTERN Flt      tolerance,	/* tolerance for intersection */
                depth_cutoff;	/* adaptive depth cutoff threshold */

EXTERN int      bunching;	/* how much in one bounding volume */

EXTERN long int global_rayid;

/* shading info */
EXTERN color    ambient_light;
EXTERN Flt     *global_ior,
                atmosphere_ior;
EXTERN int      ior_depth;

/* the list of things in the scene */
EXTERN object **light_list,	/* array of lights, so lights can be scanned quickly while shading */
               *thescene;	/* the scene itself. It is a composite object. Everything in the scene is contained in it. */
EXTERN struct camera *thecamera;/* our current camera; there can only be one. */
EXTERN Flt     *the_grid,
               *filter,
                filterconst,
                jitter_width_x,
                jitter_width_y;
EXTERN grid_tree *the_grid_tree;
EXTERN int      grid_len,
                light_list_len,
                filter_type;
EXTERN char   **library_path;
EXTERN int      libpath_len;
