/*
 * een keyboard
 *
 * David Anjo gebruikt PV3D.... om een laptop met keyboard te ontwerpen.
 * Hij is gek, met een editor en wat defines kan ik het korter en VEEL
 * sneller!
 */

// centimeters!

#define GreyPlastic = texture {
    color red 0.70 green 0.70 blue 0.70
    roughness 0.2
    specular 0.2
    ambient 0.2
    diffuse 0.5
}

#define WhitePlastic = texture {
    color red 1 green 1 blue 1
    roughness 0.2
    specular 0.2
    ambient 0.2
    diffuse 0.5
}

#define key_height = 0.5
#define key_depth = 0.9
#define key_tilt = 2

#define GreyKey = object {
    box { <0>, <0.9, key_height, key_depth> }
    texture {
        GreyPlastic
    }
    rotate x*key_tilt
}

#define WhiteKey = object {
    box { <0>, <0.9, key_height, key_depth> }
    texture {
        WhitePlastic
    }
    rotate key_tilt*x
}

#define keyboard_base = object {
    box { <-1, -1, -1>, <25, 0, 10> }
    texture { ambient 0.3 diffuse 0.5 color red 1.0 }
}

#define four_white_keys = composite {
    object { WhiteKey translate <0> }
    object { WhiteKey translate x }
    object { WhiteKey translate <2, 0, 0> }
    object { WhiteKey translate <3, 0, 0> }
    bounded_by { box { <0>, <4, key_height, 1> } }
}

#define four_grey_keys = composite {
    object { GreyKey translate <0> }
    object { GreyKey translate x }
    object { GreyKey translate <2, 0, 0> }
    object { GreyKey translate <3, 0, 0> }
    bounded_by { box { <0>, <4, key_height, 1> } }
}

#define three_grey_keys = composite {
    object { GreyKey translate <0> }
    object { GreyKey translate x }
    object { GreyKey translate <2, 0, 0> }
    bounded_by { box { <0>, <3, key_height, 1> } }
}

#define three_white_keys = composite {
    object { WhiteKey translate <0> }
    object { WhiteKey translate x }
    object { WhiteKey translate <2, 0, 0> }
    bounded_by { box { <0>, <3, key_height, 1> } }
}

#define elf_white_keys = composite {
    object { four_white_keys }
    object { four_white_keys translate <4, 0, 0> }
    object { three_white_keys translate <8, 0, 0> }
}

#define twelve_white_keys = composite {
    object { four_white_keys }
    object { four_white_keys translate <4, 0, 0> }
    object { four_white_keys translate <8, 0, 0> }
}

#define dertien_white_keys = composite {
    object { four_white_keys }
    object { four_white_keys translate <4, 0, 0> }
    object { four_white_keys translate <8, 0, 0> }
    object { WhiteKey translate <12, 0, 0> }
}

#define vert_grey_two = object {
    box { <0>, <1, key_height, 2> }
    texture { GreyPlastic }
    rotate key_tilt * x
}

#define grey_one_half = object {
    box { <0>, <1.4, key_height, key_depth> }
    texture { GreyPlastic }
    rotate key_tilt * x
}

#define grey_two = object {
    box { <0>, <1.9, key_height, key_depth> }
    texture { GreyPlastic }
    rotate key_tilt * x
}

#define white_two = object {
    box { <0>, <1.9, key_height, key_depth> }
    texture { WhitePlastic }
    rotate key_tilt * x
}

#define grey_threehalf = object {
    box { <0>, <3.4, key_height, key_depth> }
    texture { GreyPlastic }
    rotate key_tilt * x
}

#define grey_twohalf = object {
    box { <0>, <2.4, key_height, key_depth> }
    texture { GreyPlastic }
    rotate key_tilt * x
}

#define spacebar = object {
    box { <0>, <6.9, key_height, key_depth> }
    texture { WhitePlastic }
    rotate key_tilt * x
}

#define bottom_keys = composite {
    object { grey_one_half }	// left ctrl
    object { grey_one_half translate <2.5, 0, 0> }	// left alt
    object { spacebar translate <4, 0, 0> }
    object { grey_one_half translate <11, 0, 0> }	// right alt
    object { grey_one_half translate <13.5, 0, 0> }  	// right ctrl
}

#define zxcvb = composite {
    object { grey_one_half }				// left shift
    object { elf_white_keys translate <1.5, 0, 0> }
    object { grey_twohalf translate <12.5, 0, 0> }	// right shift
}

#define asdfg = composite {
    object { grey_two }	// caps lock
    object { twelve_white_keys translate <2, 0, 0> }
}

#define qwert = composite {
    object { grey_one_half }	// tab
    object { twelve_white_keys translate <1.5, 0, 0> }
}

#define topnums = composite {
    object { dertien_white_keys  }
    object { grey_two translate <13, 0, 0> }	// bksp
}

#define func_keys = composite {
    object { GreyKey }	// esc
    object { four_white_keys translate <2, 0, 0> }
    object { four_grey_keys translate <6.5, 0, 0> }
    object { four_white_keys translate <11, 0, 0> }
}

#define left_part = composite {
    object { bottom_keys }
    object { zxcvb translate z }
    object { asdfg translate <0, 0, 2> }
    object { qwert translate <0, 0, 3> }
    object { topnums translate <0, 0, 4> }
    object { func_keys translate <0, 0, 6.5> }
    object { vert_grey_two translate <14, 0, 2> }	// return
    bounded_by { box { <0>, <15, key_height, 7.5> } }
}

#define middle_part = composite {
    object { three_grey_keys translate <0> }
    object { GreyKey translate <1, 0, 1> }
    object { three_grey_keys translate <0, 0, 3> }
    object { three_grey_keys translate <0, 0, 4> }
    object { three_grey_keys translate <0, 0, 6.5> }
    bounded_by { box { <0>, <3, key_height, 7.5> } }
}

#define numpad = composite {
    object { white_two }
    object { WhiteKey translate <2, 0, 0> }
    object { three_white_keys }
    object { three_white_keys translate z }
    object { three_white_keys translate <0, 0, 2> }
    object { three_white_keys translate <0, 0, 3> }
    object { three_grey_keys translate <0, 0, 4> }
    
    object { vert_grey_two translate <3, 0, 0> }
    object { vert_grey_two translate <3, 0, 2> }
    object { GreyKey translate <3, 0, 4> }
    bounded_by { box { <0>, <4, key_height, 5> } }
}


#define keyboard = composite {
    object { keyboard_base }
    object { left_part }
    object { middle_part translate <15.5, 0, 0> }
    object { numpad translate <19, 0, 0> }
    bounded_by { box { <-1, -1, -1>, <25, 1, 11> }   }
    rotate <-key_tilt, 0, 0>
    scale <0.02, 0.02, 0.02>	// nu in cm
}

