/*
   Just an idea.

   A lamp on a table, demonstrating falloff of light. Note the heavy aliasing effects in the penumbra


   Tests shadowcache: with: 1.9 ms/ray
     without: 2.5 ms/ray

   1993 HWN
*/

#include "standard.inc"
#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"

camera {
    location <-130, 200, -200>
    sky y
    fov 40
    look_at <0, 150, 0>
}

#define Cream = color rgb <0.9, 1.0, 1.0>

#define Wall_Text = texture {
    diffuse color Cream diffuse 0.8
    ambient color Cream ambient 0.2
}

#define  wall = object {
    plane { -z, 0 }
    texture {
        Wall_Text
    }
}


#define Wood_Texture = texture {
    diffuse color Brown diffuse 0.45
    ambient color Brown ambient 0.05
}

#define leg = box { <-4, 0, -4>, <4, 100, 4> }

#define table = composite {
    object { leg translate <-100, 0, 50> }
    object { leg translate <100, 0, 50> }
    object { leg translate <-100, 0, 50> }
    object { leg translate <100, 0, 50> }
    box { <-110, 100, -60>, <110, 110, 60> }
    texture { Wood_Texture }
}

#define cap = object {
    object { QCone_Y }
    bounded_by  { box { <-100, -20, -100>, <100, -40, 100> } }
    clipped_by { bounded_by }
    translate 40*y
    texture  {
        ambient color rgb 0.7 * <color CornflowerBlue>
        diffuse color rgb 0.3 * <color CornflowerBlue>
    }
}

#define stand = composite {
    cylinder { <0>, <0, 32, 0>, 3 }
    cylinder { <0>, 3 * y,  15 }
    torus { 15, 1.5 translate 1.5*y }
    light_source {
        y*45 color rgb 10*<color Yellow>
        radius 4 attenuation 1
    }
    texture { Brass_Metal }
}

#define lamp = composite {
    object {
        stand
    }
    object { cap translate y*30 }
}

/**********************/

object { table
    translate z*-60
}

object { wall }

object { lamp translate <0, 110, -40> }
object { light_source { <-200, 200, -200> color rgb 0.2*<1, 1, 1> } }





