/*

Wow! A file with megamany prims, among which 40 lightsources, 40
fogsources and 60 torii.  Boy, I am happy to have a shadow cache! and
BSP! And CSG autobounding!  I wonder how PoV would perform :)

    /HWN/


  [After some time] Hmmm... 3 hours. I guess Rayce is faster on this one than
  PoV :-)

 (this of course has got something to do with the CSG autobounding that rayce has :)

*/

#include "standard.inc"
#include "colors.inc"
#include "textures.inc"

#define dikte = 1e-1
#define kaarskleur  = color rgb <.1>

#define wax = texture {
    color rgb <1>
    microfacet Blinn angle 15
}

#define kaars = composite {
    cylinder { <0>, y, dikte*9/10 texture { wax } }
    light_source { <0, 1.3, 0> color kaarskleur attenuation .5 }
    light_source {
        1.2*y color rgb 0.004 * <color Yellow>
        fogsource attenuation 5 direction y tightness 5
    }
    sphere { <0>, dikte *1.5 }
}

#define arm = composite {
    intersection {
        torus { 1, dikte rotate 90*x }
        plane { -y, 0 }
        translate 1*x
    }
    cylinder { 2 * x, <2, -3, 0>, dikte }
    intersection {
        torus { .75, dikte rotate 90*x }
        plane { y, 0 }
        translate 2.75*x -2*y
    }
    object { kaars translate <3.5, -2, 0> }
    intersection {
        torus { 1.35, dikte rotate 90*x }
        plane { y, 0 }
        translate 3.35*x -3*y
    }
    object { kaars translate <4.7, -3, 0> }
    translate x
}

#define sstraal = .3

#define schakel1 = torus {
    sstraal, dikte/2
    rotate 90*x
    sturm
}

#define schakel2 = torus {
    sstraal, dikte/2
    rotate 90*x+90*y
    sturm
}

#define ketstep = (sstraal - dikte / 2) * 2

#define schakels = composite {
    object { schakel1 }
    object { schakel2 translate ketstep*y }
}

#define ketting = composite {
    object { schakels }
    translate ketstep * 2 *y
    object { schakels }
    translate ketstep * 2 *y
    object { schakels }
    translate ketstep * 2 *y
    object { schakels }
    translate ketstep * 2 *y
    object { schakels }
    translate ketstep * 2 *y
    object { schakels }
    translate ketstep * 2 *y
    object { schakels }
}

#define hoek = 360 / 20
#define luchter = composite {
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    rotate hoek * y
    object { arm }
    translate -.5*y
    
    sphere {-2*y, 2 }
    object { ketting }
    
    texture {
        Brass_Metal
    }
}

object { luchter scale <.1> }

camera {
    location <.2, .2, -2> look_at <0>
    fov 40
}


