/*
   a temple I made for PoV 1.0. Never got finished.
   Needs 640 x something if you want to see everything

   HWN
*/

/*  temple dat file
	start: 15 august 1992
	convert to 1.0: 13/10/92
	roof: 8 nov 1992

	1 distance unit = 1 meter

	10 columns x 6 columns, intercolumn space: 4m
	height of col (with capitel): 8.5 meter
*/


#include "standard.inc"
#include "colors.inc"
//#include "textures.inc"
#include "shapes.inc"

/******************************************************************************/
/* viewpoint */

camera {
    location <-25, 20, -60>
    aspect 4/3
    direction 2 * x
    look_at 4 * y
    sky y
    fov 35
}

options {
//         	optimisation 0    
}
/******************************************************************************/
/* lights */

object {
    light_source { <-100, 25, -15> color White } /* low sun */
}

object {
    light_source { <20, 100, -70> color White }	/* high noon */
}

/******************************************************************************/
/* texture declarations */

#define Temple_Color = color Khaki
#define Col_Texture = // simple texture
texture {
    color Temple_Color
    diffuse 0.6
    ambient 0.4
    brilliance 0.2
    roughness 0.01
}



/******************************************************************************/
/* object declarations */

/* basic objects */

#define ground = object {
    plane { y, 0 }
    texture {
        colour green 0.4  // don't walk on the grass, smoke it.
        diffuse 0.3
        ambient 0.7
    }
}

#define Temple_Sky = object {
    sphere { <0, -10000, 0>, 11000 }
    texture {
//        turbulence 0.5        
//        Apocalypse        
        scale <30, 20, 30>
        ambient 1.0
        diffuse 0
    }
}

#define poscube = /* like cube, but entirely above xz plane */
box { <-1, 0, -1>, <1, 1, 1> }

/**********************/
/* complex objects    */
/* from bottom to top */
/**********************/

/* base of temple */
/* height: 1.2
 * dimen: 41.2 x 25.2
 */

#define steps = composite {
    object { poscube scale <19.8, 0.8, 11.8> }
    object { poscube scale <19.0, 1.2, 11.0> }
    object { poscube scale <20.6, 0.4, 12.6> }
    texture {
        Col_Texture
        color Temple_Color
    }
}

/* ramp leading to elevated part
 *
 * ??
 */

#define ramp = object {
    intersection {
        plane { -x, 0 }
        plane { -y, 0 }
        plane { <0, 0.1, -1>, 1 }
        plane { <0, 0.1, 1>, 1 }
        plane { <1, 1, 0>, 0.707 }
    }
    bounded_by { box { <0, 0, -2>, <3, 2, 2> } }
    scale <6, 1.2, 2>
    texture {
        Col_Texture
        color Temple_Color
    }
}

/***************************************************************************
 * column stuff								   *
 ***************************************************************************/

/* columns
 * big rad: 1
 * small rad: 0.66
 * height: 8
 */

#define colshaft = object {
    intersection {
        object { QCone_Y }
        plane { y, -0.6666666666 }
        plane { <0, -1, -0>, 1 }
        scale <1, 24, 1>
        translate <0, 24, 0>
    }
    bounded_by { object { poscube scale <1, 8, 1> } }
}

/* capitel
 * dimen: 2.4 x 2.4
 * height: 0.5
 */

#define capitel  = // doric
object {
    intersection {
        object { QCone_Y scale <2, 1, 2> translate -y }
        object { poscube scale <1.2, 0.5, 1.2> }
    }
}

/*
 * total column
 * height: 8.5
 * maxdimen: 2.4 x 2.4
 */

#define column = composite {
    object { colshaft }
    object { capitel translate 8 * y }
}

/*
 *	vier zuilen op een rijtje;
 */

#define fourcolumns = /* four columns in a row */
composite {
    object { column translate <0> }
    object { column translate 4 * x }
    object { column translate 8 * x }
    object { column translate <12, 0, 0> }
}


/***************************************************************************
 * all columns								   *
 ***************************************************************************/

#define allcolumns = /* outer columns */
composite {
    object { fourcolumns translate <2, 0, -9> }
    object { fourcolumns translate <-14, 0, -9> }
    object { fourcolumns translate <2, 0, 9> }
    object { fourcolumns translate <-14, 0, 9> }
    object { fourcolumns
        rotate <0, -90, 0> translate <-17, 0, -6> }
    object { fourcolumns
        rotate <0, -90, 0> translate <17, 0, -6> }
    object { column translate <17, 0, 9> }
    object { column translate <-17, 0, 9> }
    object { column translate <17, 0, -9> }
    object { column translate <-17, 0, -9> }
}

/***************************************************************************
 * The stuff which is on top						   *
 ***************************************************************************/

/* architraaf
 * 0.6 height
 * dimen 36.2 x 20.2
 */

#define
architraaf = object {
    intersection {
        object { poscube
            scale <18.1, 0.6, 10.1> }
        intersection {
            plane { x, 15.8 }
            plane { -x, 15.8 }
            plane { z, 7.8 }
            plane { -z, 7.8 }
            inverse
        }
    }
    
}

/* frieze: metope
 * ht: 1.2
 * 36.1 x 20.1
 */

#define metope = object {
    intersection {
        object { poscube scale <18.05, 1.2, 10.05> }
        intersection {
            plane { x, 15.8 }
            plane { -x, 15.8 }
            plane { z, 7.8 }
            plane { -z, 7.8 }
            inverse
        }
    }
    
    /*	texture {
		Col_Texture
		color Temple_Color
//		ripples 1.0
			// modern, highly abstract mathematical sculptures	:-)
		scale <0.3, 0.3, 0.3>
	}*/
}

/* shape to be cut out of the triglief stone */
#define glief = intersection {
    plane { <-1, 0, 1>, -0.03 }
    plane { <1, 0, 1>,  -0.03 }
    inverse
}

/* decorative stone, triglief (three ..) part of frieze
 * height 1.2
 * dimen 1x0.4
 */

#define triglief = object {
    intersection {
        object { poscube scale <0.5, 1.2, 0.2> }
        object {
            glief
        }
        object {
            glief
            translate <-0.3, 0, 0>
        }
        object {
            glief
            translate <0.3, 0, 0>
        }
    }
    
}

#define seventriglief = composite {
    object { triglief translate <0> }
    object { triglief translate 2 * x }
    object { triglief translate 4 * x }
    object { triglief translate 6 * x }
    object { triglief translate 8 * x }
    object { triglief translate <10, 0, 0> }
    object { triglief translate <12, 0, 0> }
    
}

#define triglieven = composite {
    object { seventriglief translate <2, 0, -10.05> }
    object { seventriglief translate <-14, 0, -10.05> }
    object { seventriglief
        rotate <0, 180, 0> translate <-2, 0, 10.05> }
    object { seventriglief
        rotate <0, 180, 0> translate <14, 0, 10.05> }
    object { seventriglief
        rotate <0, -90, 0> translate <18.05, 0, -6> }
    object { seventriglief
        rotate <0, 90, 0> translate <-18.05, 0, 6> }
    
    object { triglief /*rotate <0>*/ translate <0, 0, -10.05> }
    object { triglief rotate <0, 180, 0> translate <0, 0, 10.05> }
    
    object { triglief /*rotate <0>*/ translate <15.875, 0, -10.05> }
    object { triglief /*rotate <0>*/ translate <-15.875, 0, -10.05> }
    object { triglief /*rotate <0>*/ translate <17.75, 0, -10.05> }
    object { triglief /*rotate <0>*/ translate <-17.75, 0, -10.05> }
    
    object { triglief rotate <0, 180, 0> translate <15.875, 0, 10.05> }
    object { triglief rotate <0, 180, 0> translate <-15.875, 0, 10.05> }
    object { triglief rotate <0, 180, 0> translate <17.75, 0, 10.05> }
    object { triglief rotate <0, 180, 0> translate <-17.75, 0, 10.05> }
    
    object { triglief rotate <0, 90, 0> translate <-18.05, 0, 9.75> }
    object { triglief rotate <0, 90, 0> translate <-18.05, 0, -9.75> }
    object { triglief rotate <0, 90, 0> translate <-18.05, 0, 7.875> }
    object { triglief rotate <0, 90, 0> translate <-18.05, 0, -7.875> }
    
    object { triglief rotate <0, -90, 0> translate <18.05, 0, 9.75> }
    object { triglief rotate <0, -90, 0> translate <18.05, 0, -9.75> }
    object { triglief rotate <0, -90, 0> translate <18.05, 0, 7.875> }
    object { triglief rotate <0, -90, 0> translate <18.05, 0, -7.875> }
}

/* frieze: put it together
 * ht 1.2
 * dimen 36.5 x 20.5
 */

#define fries = composite {
    object {
        metope
    }
    object {
        triglieven
    }
    
}

/* 36.7 x 21.1
 * denk er om: alle vectors normaliseren!
 *
 */

#define roof = object {
    intersection {
        object { poscube scale <18.35, 10, 10.55> }
        intersection {
            plane { y, 0 rotate <-20, 0, 0> translate <0, 0.4, -10.55> }
            plane { y, 0 rotate <20, 0, 0> translate <0, 0.4, 10.55> }
        }
        intersection {
            plane { y, 0 rotate <-20, 0, 0> translate <0, 0.1, -10.55> }
            plane { y, 0 rotate <20, 0, 0> translate <0, 0.1, 10.55> }
            inverse
        }
    }
    
    texture {
        color Firebrick
        diffuse 0.6
        ambient 0.4
        brilliance 0.2
        roughness 0.01
    }
}

#define fronton = object {
    intersection {
        box { <-18.05, 0, -10.05>, <18.05, 10, 10.05> }
        intersection {
            plane { y, 0 rotate <-20, 0, 0> translate <0, 0.1, -10.55> }
            plane { y, 0 rotate <20, 0, 0> translate <0, 0.1, 10.55> }
        }
    }
    
}

/***************************************************************************
 * Inside Stuff, might need a statue or something			   *
 ***************************************************************************/

#define Inner_Texture = texture {
//          PinkAlabaster    
    color Pink
    ambient 0.8 diffuse 0.5
}

#define inner_column = object {
    cylinder { <0>, 8.5*y, .5 }
}

#define inner_floor = object {
    object { poscube scale <15, 0.2, 5> }
}
#define inner_cols_X = composite {
    object { inner_column translate <-13.5, 0, 0> }
    object { inner_column translate <-10, 0, 0> }
    object { inner_column translate <-6, 0, 0> }
    object { inner_column translate <-2, 0, 0> }
    object { inner_column translate 2 * x }
    object { inner_column translate 6 * x }
    object { inner_column translate <10, 0, 0> }
    object { inner_column translate <13.5, 0, 0> }
    
}

#define inner_cols_Y = composite {
    object { inner_column translate <0, 0, -2.0> }
    object { inner_column translate <0, 0, 2.0> }
    
}

#define inner_stuff = composite {
    object { inner_floor }
    object { light_source { y color red 2.0 blue 1.0 } }
    object { inner_cols_X translate <0, 0.2, -3.5> }
    object { inner_cols_X translate <0, 0.2, 3.5> }
    object { inner_cols_Y translate <-13.5, 0.2, 0> }
    object { inner_cols_Y translate <13.5, 0.2, 0> }
    object {
        intersection {
            box { <-15, 5.5, -5>, <15, 6.0, 5> }
            box { <-13, 5.5, -3>, <13, 6.0, 3> inverse }
        }
        
    }
    texture { Inner_Texture } // rnd values.
}

/***************************************************************************
 * temple:  put it together						   *
 ***************************************************************************/

#define temple = composite {
    object { allcolumns translate <0, 1.20, 0> }
    object { steps }
    object { ramp translate <19, 0, 0> }
    
    object { architraaf translate <0, 9.7, 0> }
    object { fries translate <0, 10.3, 0> }
    object { roof translate <0, 11.5, 0> }
    object { fronton translate <0, 11.5, 0> }
    object { inner_stuff translate <0, 1.2, 0> }
    texture { Col_Texture }
}

/******************************************************************************/
/* objects in scene */

object { ground }
object { temple }
//object { Temple_Sky }
